<template>
  <div class="service-selector">
    <div class="service-selector__transport">
      <ob-select
          v-model="activeTransportType"
          label="Услуга"
          :items="transports"
          placeholder="Выберите из списка"
          position="top"
          :isStandart="true"
          :disabled="transports.length === 1 || disableTransportType"
          popperClass="transport-type-popper"
          data-qa="transportKind"
          @selected="setServicesAll(null)"
      />
    </div>
    <div class="service-selector__transport-type">
      <ob-select
          v-model="activeTransport"
          class="transport-type-select"
          :label="$options.transportLabels[activeTransportationWay].subtype"
          :items="transportsTypesGrouped"
          placeholder="Выберите из списка"
          position="top"
          :isStandart="true"
          :disabled="disableTransport"
          :required="isTransportTypeRequired"
          :is-dropdown="isMultiselectTransport"
          data-qa="transportType"
      />
    </div>
  </div>
</template>

<script>
import api from "@/api";
import ObSelect from "common-components/src/obComponents/obSelect";

export default {
  name: "ServiceSelector",

  transportLabels: {
    FTL: {
      label: "Какой автотранспорт",
      type: "Вид автотранспорта",
      subtype: "Тип автотранспорта",
    },
    CONTAINER: {
      label: "Какие контейнеры",
      type: "Вид контейнера",
      subtype: "Тип контейнера",
    },
    RAIL: {
      label: "Какой ЖД транспорт",
      type: "Вид ЖД транспорта",
      subtype: "Тип ЖД транспорта",
    },
  },

  components: {
    ObSelect,
  },

  props: {
    initialActiveTransport: {
      type: [String, Array],
      default: null
    },

    isTransportTypeRequired: {
      type: Boolean,
      default: false,
    },

    disableTransportType: {
      type: Boolean,
      default: false,
    },

    disableTransport: {
      type: Boolean,
      default: false,
    },

    isMultiselectTransport: {
      type: Boolean,
      default: false,
    },

    activeTransportationWay: {
      type: String,
      default: 'FTL'
    },

    disableItemFunc: {
      type: Function,
      default: () => false
    }

  },

  data() {
    return {
      activeTransportType: '',
      activeTransport: [],
      transports: [],
      transportTypes: [],
      transportsTypesGrouped: [],
    }
  },

  computed: {},

  watch: {
    initialActiveTransport() {
      this.onLoadSaved();
    },
    activeTransport() {
      this.$emit("activeTransportTypeChanged", this.activeTransport);
    }
  },

  mounted() {
    this.setTransports();
    this.onLoadSaved();
  },

  methods: {

    onLoadSaved() {
      if (this.initialActiveTransport) {
        this.activeTransport = this.initialActiveTransport;
        this.setServicesAll(this.initialActiveTransport);
      } else {
        this.activeTransport = this.isMultiselectTransport ? [] : '';
        this.setTransports();
      }
    },

    async setTransports() {
      try {
        this.transports = await api.orders.getTransport(
            this.activeTransportationWay
        );
        if (this.activeTransport.length === 0) {
          this.activeTransportType = this.transports[0].uuid;
          this.setServicesAll(null);
        }
      } catch (err) {
        console.error(err);
      }
    },

    async setServicesAll(serviceUuid) {
      const hasServiceUuid = Array.isArray(serviceUuid) ? serviceUuid.length > 0 : serviceUuid;
      const params = hasServiceUuid ?
          {
            isActive: true,
            serviceUuids: Array.isArray(serviceUuid) ? serviceUuid : [ serviceUuid ]
          } :
          {
            isActive: true,
            serviceTypeUuids: [ this.activeTransportType ]
          }
      try {
        const types = await api.services.getServicesAll(params);
        this.transportsTypes = types;
        this.transportsTypesGrouped = this.groupTransportTypes(types);
        if (hasServiceUuid) {
          this.activeTransportType = this.transportsTypes[0]?.serviceTypeUuid;
          this.setServicesAll(null);
        }
      } catch (err) {
        console.error(err);
      }
    },

    groupTransportTypes(types) {
      const GROUP_SIZE_MIN = 6;
      let groups = [];
      const groupsMap = {};
      if (types) {
        if (types.length > GROUP_SIZE_MIN) {
          types.forEach(type => {
            if (!groupsMap[type.resourceSubtypeUuid]) {
              groupsMap[type.resourceSubtypeUuid] = {
                title: type.resourceSubtypeTitle,
                defaultGroupElementUuid: null,
                hideSelectButton: true,
                children: []
              };
            }
            type.title = this.getTransportItemTitle(type);
            type.disabled = this.disableItemFunc(type.uuid);
            groupsMap[type.resourceSubtypeUuid].children.push(type);
          })

          Object.keys(groupsMap).forEach(key => {
            let group = groupsMap[key];
            let defaulItem = group.children.filter(item => item.isDefaultForSubtype);
            if (defaulItem.length === 1) {
              group.defaultGroupElementUuid = defaulItem[0].uuid;
              group.hideSelectButton = true;
            }
            groups.push(group);
          })
        } else {
          groups = types.map(type => {
            type.title = this.getTransportItemTitle(type);
            type.disabled = this.disableItemFunc(type.uuid);
            return type;
          });
        }
      }

      return groups;
    },

    getTransportItemTitle (item) {
      return item.resourceSubtypeTitle + " " + item.resourcePatternParameter;
    },

  },
}
</script>

<style lang="scss">

.service-selector {
  display: flex;

  &__transport {
    margin-right: 10px;
    width: 33%;
    display: flex;
    min-width: 250px;

    .ob-selector {
      width: 100%;
    }
  }

  &__transport-type {
    flex-grow: 1;
  }
}

</style>
